<?php
/*
 * 此文件用于验证短信服务API接口，供开发时参考
 * 执行验证前请确保文件为utf-8编码，并替换相应参数为您自己的信息，并取消相关调用的注释
 * 建议验证前先执行Test.php验证PHP环境
 *
 * 2017/11/30
 */
namespace FoxSms;

class Aliyun {

    private $accessKeyId;
    private $accessKeySecret;
    public function __construct($accessKeyId, $accessKeySecret)
    {
        $this->accessKeyId = $accessKeyId;
        $this->accessKeySecret  = $accessKeySecret;
    }

    /**
     * @param $options
     * 发送验证码
     */
    public function send($options = []) {
        
        $userId=$this->accessKeyId; //用户ID
        $password=$this->accessKeySecret; //用户密码
        $phone=implode(',', $options['PhoneNumbers']); //要发送的手机号，多个手机号使用英文逗号分隔
        $signName=$options['SignName']; //签名ID
        $tempId=$options['TemplateCode']; //模板ID
        $varParam=json_encode($options['TemplateParam']); //模板变量参数
        $varParam=base64_encode($varParam); //将json转换为base64编码
        $source_id=''; //渠道ID
        $time=time(); //时间戳
        $sign=md5($userId.md5($password).$tempId.$signName.$time.$source_id); //计算签名
        $data="userId={$userId}&phone={$phone}&tempId={$tempId}&signName={$signName}&timeStamp={$time}&varParam={$varParam}&sign={$sign}&source_id={$source_id}"; //拼接待提交数据
        $res=$this->curl_request('https://www.smspt.cn'.'/sms/api_v1.php?mod=sendMessageGroup',$data); //发送请求
        $res=json_decode($res,true);
        if($res['code']==1){
            return [
                'errno' => 0
            ];
        }else{
            return [
                'errno' => 1,
                'message' => $res['msg']
            ];
        }
        
    }
    


/**
 * 使用CURL进行HTTP请求
 * 参数1：访问的URL，
 * 参数2：post数据(不填则为GET)，
 * 参数3：提交的$cookies,
 * 参数4：是否返回$cookies
 */
private function curl_request($url, $post = '', $cookie = '', $returnCookie = 0, $httpHeader=[]){
    $curl = curl_init();
    
    curl_setopt($curl, CURLOPT_URL, $url);
    curl_setopt($curl, CURLOPT_USERAGENT, 'Mozilla/5.0 (compatible; MSIE 10.0; Windows NT 6.1; Trident/6.0)');
    curl_setopt($curl, CURLOPT_FOLLOWLOCATION, 1);
    curl_setopt($curl, CURLOPT_AUTOREFERER, 1);
    // curl_setopt($curl, CURLOPT_REFERER, "http://XXX");
    
    if ($post) {
        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_POSTFIELDS, $post);
    }
    if ($cookie) {
        curl_setopt($curl, CURLOPT_COOKIE, $cookie);
    }
    curl_setopt($curl, CURLOPT_HTTPHEADER, $httpHeader);
    curl_setopt($curl, CURLOPT_HEADER, $returnCookie);
    curl_setopt($curl, CURLOPT_TIMEOUT, 60);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
    curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 0);
    $data = curl_exec($curl);
    if (curl_errno($curl)) {
        return '';
    }
    curl_close($curl);
    if ($returnCookie) {
        list($header, $body) = explode("\r\n\r\n", $data, 2);
        preg_match_all("/Set\-Cookie:([^;]*);/", $header, $matches);
        $info['cookie'] = substr($matches[1][0], 1);
        $info['content'] = $body;
        return $info;
    } else {
        return $data;
    }
}
    
}
